<p style="color:red;"><b>At LinkedIn, we are focusing our efforts on advanced automation to enable a seamless, LinkedIn-wide migration from Rest.li to <a href="https://grpc.io/">gRPC</a>. gRPC will offer better performance, support for more programming languages, streaming, and a robust open source community. There is no active development at LinkedIn on new features for Rest.li. The repository will also be deprecated soon once we have migrated services to use gRPC. Refer to <a href="https://engineering.linkedin.com/blog/2023/linkedin-integrates-protocol-buffers-with-rest-li-for-improved-m">this blog</a> for more details on why we are moving to gRPC.</b></p>

<p align="center">
  <img src="https://github.com/linkedin/rest.li/wiki/restli-logo-white-small.png"/>
</p>

Rest.li is an open source REST framework for building robust, scalable RESTful
architectures using type-safe bindings and asynchronous, non-blocking IO. Rest.li
fills a niche for applying RESTful principles at scale with an end-to-end developer
workflow for building REST APIs, which promotes clean REST practices, uniform
interface design and consistent data modeling.

<p align="center"><a href="https://github.com/linkedin/rest.li">Source</a> | <a href="https://rest.li">Documentation</a> | <a href="https://www.linkedin.com/groups/4855943/">Discussion Group</a></p>

Features
--------

* [End-to-end framework](https://linkedin.github.io/rest.li/user_guide/server_architecture#development-flow) for building RESTful APIs
* Approachable APIs for writing non-blocking client and server code using [ParSeq](https://github.com/linkedin/parseq)
* Type-safe development using generated data and client bindings
* [JAX-RS](http://en.wikipedia.org/wiki/Java_API_for_RESTful_Web_Services) inspired annotation driven server side resource development
* Engineered and battle tested for high scalability and high availability
* Optional [Dynamic Discovery](https://linkedin.github.io/rest.li/Dynamic_Discovery) subsystem adds client side load balancing and fault tolerance
* Backward compatibility checking to ensure all API changes are safe
* Support for batch operations, partial updates and projections
* [Web UI](https://github.com/linkedin/rest.li-api-hub) for browsing and searching a catalog of rest.li APIs.

Website
-------
[https://rest.li](https://rest.li)

Documentation
-------------

See our [website](https://rest.li) for full documentation and examples.

Community
---------
* Discussion Group: [LinkedIn Rest.li Group](https://www.linkedin.com/groups/4855943/)
* Follow us on Twitter: [@rest_li](https://twitter.com/rest_li)
* Issue Tracking: [GitHub issue tracking](https://github.com/linkedin/rest.li/issues)

Quickstart Guides and Examples
------------------------------

* [Quickstart - a step-by-step tutorial on the basics](https://linkedin.github.io/rest.li/start/step_by_step)
* [Guided walkthrough of an example application](https://linkedin.github.io/rest.li/get_started/quick_start)
