/*
   Copyright (c) 2012 LinkedIn Corp.

   Licensed under the Apache License, Version 2.0 (the "License");
   you may not use this file except in compliance with the License.
   You may obtain a copy of the License at

       http://www.apache.org/licenses/LICENSE-2.0

   Unless required by applicable law or agreed to in writing, software
   distributed under the License is distributed on an "AS IS" BASIS,
   WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
   See the License for the specific language governing permissions and
   limitations under the License.
*/

package com.linkedin.data.avro;


import java.io.IOException;
import java.io.OutputStream;
import java.util.Map;
import org.apache.avro.Schema;
import org.apache.avro.generic.GenericData;
import org.apache.avro.io.Decoder;
import org.apache.avro.io.Encoder;


/**
 * Adapter to handle incompatibilities among different versions of Avro.
 *
 * <p>
 * @see AvroAdapterFinder
 * @deprecated use {@link com.linkedin.avroutil1.compatibility.AvroCompatibilityHelper} instead.
 */
@Deprecated
public interface AvroAdapter
{
  /* see AVRO-656 */
  boolean jsonUnionMemberHasFullName();

  GenericData.EnumSymbol createEnumSymbol(Schema avroSchema, String enumValue);

  Schema stringToAvroSchema(String avroSchemaJson);

  Decoder createBinaryDecoder(byte[] bytes) throws IOException;

  Encoder createBinaryEncoder(OutputStream outputStream) throws IOException;

  Decoder createJsonDecoder(Schema schema, String json) throws IOException;

  Encoder createJsonEncoder(Schema schema, OutputStream outputStream) throws IOException;
}
